function flow = ComputeFlowsAlt(f, maxIt, smooth)
%% compute with HS implementation from Deqing Sun

% Copyright 2019 Georg Radow <radow@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 15.08.2018 13:30

[nr, nc, nImg] = size(f);
flow = zeros(nr,nc,2,nImg-1);

opticFlow = opticalFlowHS('Smoothness',smooth,'MaxIteration',maxIt);
for ii=1:nImg
    tmp = estimateFlow(opticFlow,f(:,:,ii));
    if ii>1
        flow(:,:,1,ii-1) = tmp.Vx;
        flow(:,:,2,ii-1) = tmp.Vy;
    end
end

% cd hs
% 
% [nr, nc, nImg] = size(f);
% flow = zeros(nr,nc,2,nImg-1);
% 
% for ii=2:nImg
%     flow(:,:,:,ii-1) = estimate_flow_hs(f(:,:,ii-1),f(:,:,ii),'lambda',smooth);
% end
% 
% cd ..

end

