function [v, err, ssi] = rebuildVideoNGVO(c, f)

% Copyright 2018 Laurent Hoeltgen <contact@laurenthoeltgen.name>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision on: 20.06.2018 13:13

[nr, nc, nd] = size(f);
nn = nr*nc;

D1y   = sparse(1:(nr-1), 2:nr, 1, nr, nr) - speye(nr, nr); D1y(nr, nr) = 0;
D1x   = sparse(1:(nc-1), 2:nc, 1, nc, nc) - speye(nc, nc); D1x(nc, nc) = 0;
DxDy  = [ kron(D1x, speye(nr,nr)) ;  kron(speye(nc,nc), D1y) ];
Dxxyy = -DxDy'*DxDy;

v   = zeros(size(f));
err = zeros(1,nd);
ssi = err;

for ii = 1:nd
    tmp  = c(:, :, ii);
    tmp2 = f(:, :, ii);
    %
    A = sparse(1:nn, 1:nn, tmp(:)) + ...
        (speye(nn,nn) - sparse(1:nn, 1:nn, tmp(:)))*(-Dxxyy);
    
    v(:, :, ii) = reshape(A\(tmp(:).*tmp2(:)), [nr, nc]);
    err(ii) = norm(v(:,:,ii) - f(:,:,ii),'fro')^2/(nr*nc);
    ssi(ii) = ssim(v(:,:,ii),f(:,:,ii));
end
end