function d = moveMask(c, flow, clusterQ)

[nr, nc, ~, nd] = size(flow);

d = zeros(nr, nc, nd + 1);
d(:,:,1) = c;

nCl = max(1,sum(abs(c(:)) > 0.01));

for ii = 2:(nd + 1)    
    % Shift mask points (currently w/ rounding and w/o registration) 
    tmp = ftransp(d(:,:,ii-1), flow(:,:,1,ii-1), flow(:,:,2,ii-1), true);
    
    if clusterQ
        %% Cluster (not recommended)
        
        [pax, pay] = find(tmp);
        pa = sub2ind(size(tmp), pax, pay);
        va = tmp(pa);
        
        [idx, C] = kmeans([pax, pay, va], min([nCl, floor(0.25*numel(va)), 7500]));
        
        Crx = round(C(:,1));
        Cry = round(C(:,2));
        out = zeros(size(tmp));
        
        for jj = 1:max(idx)
            out(Crx(jj),Cry(jj)) = sum(va(idx(jj))); % idx(ii);
        end
    else
        % Cut of mask values > 1
        tmp = round(tmp);
        tmp(tmp > 1) = 1;
        out = tmp;
    end
    
    % Save clustered mask
    d(:,:,ii) = out;
end

end