function [v, err, ssi] = rebuildVideoNGVO(c, f)

[nr, nc, nd] = size(f);
nn = nr*nc;

D1y   = sparse(1:(nr-1), 2:nr, 1, nr, nr) - speye(nr, nr); D1y(nr, nr) = 0;
D1x   = sparse(1:(nc-1), 2:nc, 1, nc, nc) - speye(nc, nc); D1x(nc, nc) = 0;
DxDy  = [ kron(D1x, speye(nr,nr)) ;  kron(speye(nc,nc), D1y) ];
Dxxyy = -DxDy'*DxDy;

v   = zeros(size(f));
err = zeros(1,nd);
ssi = err;

for ii = 1:nd
    tmp  = c(:, :, ii);
    tmp2 = f(:, :, ii);
    %
    A = sparse(1:nn, 1:nn, tmp(:)) + ...
        (speye(nn,nn) - sparse(1:nn, 1:nn, tmp(:)))*(-Dxxyy);
    
    v(:, :, ii) = reshape(A\(tmp(:).*tmp2(:)), [nr, nc]);
    err(ii) = norm(v(:,:,ii) - f(:,:,ii),'fro')^2/(nr*nc);
    ssi(ii) = ssim(v(:,:,ii),f(:,:,ii));
end
end